#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <stack>
#include <queue>
#include <iomanip>

#define INF 2000000000
#define EPS 1e-6
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define PI pair<int,int>
#define UI unsigned int
#define PQ priority_queue
#define W1 while(1)
#define PD pair<double,double>
#define VI vector<int>
#define PB push_back
#define SZ size()
#define MP make_pair
#define x first
#define y second

#define pause system("pause")

using namespace std;

int n,m;

int Min[16][50100],Max[16][50100];

inline int qrymin(int st,int en)
{
    int lev=0;
    while (st+(1<<lev)-1<=en) lev++;
    lev--;
//    cout<<lev<<" "<<st+(1<<lev)-1<<endl;
    return min(Min[lev][st],Min[lev][en-((1<<lev)-1)]);
}

inline int qrymax(int st,int en)
{
    int lev=0;
    while (st+(1<<lev)-1<=en) lev++;
    lev--;
//    cout<<lev<<" "<<st+(1<<lev)-1<<endl;
    return max(Max[lev][st],Max[lev][en-((1<<lev)-1)]);
}

int main()
{
    int i,j,k,l,X,Y;
     scanf("%d%d",&n,&m);
     memset(Min,127,sizeof(Min));
     Repi(n)
     {
      scanf("%d",&l);
      Min[0][i+1]=l;
      Max[0][i+1]=l;
     }
    
     for (int i=1; i<16; i++)
      for (int j=1; j<=n-(1<<i)+1; j++)
       {
               Min[i][j]=min(Min[i-1][j],Min[i-1][j+(1<<(i-1))]);
               Max[i][j]=max(Max[i-1][j],Max[i-1][j+(1<<(i-1))]);
       }
    
/*     Repi(16)
     {
      Repj(n+1)
       cout<<Min[i][j]<<" ";
      cout<<endl; 
     }
     cout<<endl;
     Repi(16)
     {
      Repj(n+1)
       cout<<Max[i][j]<<" ";
      cout<<endl; 
     }
   */
     Repi(m)
     {
            scanf("%d%d",&j,&k);
            X=qrymin(j,k);
            Y=qrymax(j,k);
        //    cout<<j<<" "<<k<<" -> "<<X<<" "<<Y<<endl;
            printf("%d\n",Y-X);
     }
    
     return 0;
}
