#include <cstdio>
#include <algorithm>
#include <time.h>
using namespace std;
 
const int MAXN = 65537;
const int INF = 1 << 20;
const int H = 17;

int i, j, n, N, N2,m;
int t1[MAXN * 2];// 500k
int t2[MAXN * 2];// 500k
int a[MAXN];// 250k
struct A{int l, r, med;} s[MAXN * 2];// 1.5MB
//total ~ 2.75MB + 1MB stack

int qmax (int pos, int l, int r) { //max
	if (l > r) return -1;
	if (l == r) return t1[N + l - 1];
	if (l == s[pos].l && r == s[pos].r) return t1[pos];
	
	if (l > s[pos].med) { //dqsno
		return qmax (pos * 2 + 1, l, r);
	}
	else if (r > s[pos].med) { // cepi
		return max (qmax (pos * 2, l, s[pos].med), qmax (pos * 2 + 1, s[pos].med + 1, r));
	}
	else { // lqvo
		return qmax (pos * 2, l, r);
	}
	return -1;
}

int qmin (int pos, int l, int r) { //min
	if (l > r) return INF;
	if (l == r) return t2[N + l - 1];
	if (l == s[pos].l && r == s[pos].r) return t2[pos];
	
	if (l > s[pos].med) { //dqsno
		return qmin (pos * 2 + 1, l, r);
	}
	else if (r > s[pos].med) { // cepi
		return min (qmin (pos * 2, l, s[pos].med), qmin (pos * 2 + 1, s[pos].med + 1, r));
	}
	else { // lqvo
		return qmin (pos * 2, l, r);
	}
	return INF;
}

void init () {
	//read input
	//
	scanf ("%d %d", &n, &m);
	for (i = 1; i <= n; i++) scanf ("%d", &a[i]);
	for (i = 1; i < n; i *= 2);
	N = i;
	N2 = N * 2;
//printf ("%d %d\n", N, N2);
	for (s[1].l = 1, s[1].r = N, s[1].med = N/2, i = 2; i < N2; i++) {
		if (i%2) {
			s[i].l = s[i/2].med + 1;
			s[i].r = s[i/2].r;
			s[i].med = (s[i].l + s[i].r) / 2;
		}
		else {
			s[i].l = s[i/2].l;
			s[i].r = s[i/2].med;
			s[i].med = (s[i].l + s[i].r) / 2;
		}
	}
	i = N2;
	while (i > 0) {
		for (j = i/2; j < i; j++) {
			if (j >= N) t1[j] = a[j - N + 1];
			else t1[j] = max (t1[j * 2], t1[j * 2 + 1]); // ! masive a with zeros or INF
		}
		i /= 2;
	}
	for (i = n+1; i <= N; i++) a[i] = INF;
	i = N2;
	while (i > 0) {
		for (j = i/2; j < i; j++) {
			if (j >= N) t2[j] = a[j - N + 1];
			else t2[j] = min (t2[j * 2], t2[j * 2 + 1]); // ! masive a with zeros or INF
		}
		i /= 2;
	}
}

void solve () {
	//for (i = 1; i < N2; i++) printf ("%d [%d, %d, %d]\n",i, s[i].l, s[i].r, s[i].med);
	//for (i = 1; i < N2; i++) printf ("t1[%d,  %d %d] = %d\n", i, s[i].l, s[i].r, t1[i]);
	//printf ("q 3 8 = %d", qmin (1, 6, 8));
	int q1, q2, ans1, ans2, w=0;
	for (i = 1; i <= m; i++) {
		scanf ("%d %d", &q1, &q2);
		printf ("%d\n", qmax (1, q1, q2) - qmin (1, q1, q2));
	}
}

int main () {//clock_t beg = clock();
	//freopen ("asd", "rt", stdin);
	//freopen ("asd2", "wt", stdout);
	init ();
	solve ();
	//printf ("time = %f\n", (double)(clock() - beg) / CLOCKS_PER_SEC);
	return 0;
}
