#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#define maxN 10005
#define maxV (1<<20)
#define MOD 1000000000

using namespace std;

int m,n,panic;
vector <int> G[maxN];
vector <int> G_[maxN];
int deg[maxN];
int res[maxN];
char can[maxN];

void input()
{
     int i,a,b;
     scanf("%d%d",&n,&m);
     for (i=0;i<m;++i) {
         scanf("%d%d",&a,&b);
         G[a].push_back(b);
         G_[b].push_back(a);
         ++deg[b];
         }
     res[1] = 1;
}

void bfs()
{
     queue <int> q;
     int i,j;
     q.push(2); 
     while (!q.empty()) {
           i = q.front();
           q.pop();
           can[i] = 1;
           for (j=0;j<G_[i].size();++j) if (!can[G_[i][j]]) {q.push(G_[i][j]);can[G_[i][j]]=1;}
           }
     /*for (i=1;i<=n;++i) printf("%d",can[i]);*/
}

void solve()
{
     int i,j,k,min,br;
     if (can[1] == 0) printf("0\n");
     if (deg[1] > 0) {printf("inf\n");exit(0);}
     while (1) {
           min = maxV; k = 0;
           for (i=1;i<=n;++i) {
               if (deg[i] < min) min = deg[i];
               if (deg[i] == 0) { k = 1;
                  for (j=0;j<G[i].size();++j) {
                      res[G[i][j]] = res[G[i][j]] + res[i];
                      if (res[G[i][j]] > MOD) {panic=1;res[G[i][j]]%=MOD;}
                      deg[G[i][j]]--;
                      }
                  deg[i] = maxV;
                  goto hah;
                  }
               }
           if (k == 0 && min < maxV) {
              for (i=1;i<=n;++i) if (deg[i] == min && can[i]) {printf("inf\n");exit(0);}
              }
           if (!k) break;
           hah:;
           }
     if (panic)
        for (i=0;i<8-(int)log10(res[2]);++i) printf("0");
     printf("%d\n",res[2]);
}

int main()
{
    input();
    bfs();
    solve();
    return 0;
}
