#include <stdio.h>
#include <math.h>
#define maxN (1<<17)
#define maxK 16
#define maxV (1<<20)

#define MMAX(a,b) ((a)>(b)?(a):(b))
#define MMIN(a,b) ((a)<(b)?(a):(b))

int m,n;
int min[maxN][maxK], max[maxN][maxK];

void input()
{
     int i,p,j;
     for (i=0;i<maxN;++i) 
         for (j=0;j<maxK;++j) min[i][j] = maxV;
     scanf("%d%d",&n,&m);
     for (i=1;i<=n;++i) {
         scanf("%d",&p);
         min[i][0] = max[i][0] = p;
         }
}

void build()
{
     int i,j;
     for (j=1;j<maxK;++j)
         for (i=1;i<=n;++i) {
             min[i][j] = MMIN(min[i][j-1],min[i+(1<<(j-1))][j-1]);
             max[i][j] = MMAX(max[i][j-1],max[i+(1<<(j-1))][j-1]);
             }
}

int logg(int p)
{
    int res=0;
    if (p == 0) return 0;
    while (p!=1) {p>>=1;++res;}
    return res;
}

void solve()
{
     int i,a,b,p,_min,_max;
     for (i=1;i<=m;++i) {
         scanf("%d%d",&a,&b);
         p = logg(b-a);
         _min = MMIN(min[a][p], min[b-(1<<p)+1][p]);
         _max = MMAX(max[a][p], max[b-(1<<p)+1][p]);
         printf("%d\n",_max-_min);
         }
}

int main()
{
    input();
    build();
    solve();
    return 0;
}
