#include <iostream>
#include <iomanip>
#include <vector>
#include <ctime>

#define MAXN 10005
#define MAXM 100005
#define PB push_back

using namespace std;

int n,m,p,q;
vector<int> a[MAXN];
long long was[MAXN],t=1;

int bfs()
{
	int q[MAXM];
	bool used[MAXN];
	int c=0,end=1,lev=1;
	q[0]=1;
	used[1]=1;
	while(c<end)
	{
		for(;c<lev;c++)
		{
			if(q[c]==2)
				return 1;
			for(int i=0;i<a[q[c]].size();i++)
				if(!used[a[q[c]][i]])
				{
					q[end++]=a[q[c]][i];
					used[a[q[c]][i]]=1;
				}
		}
		lev=end;
	}
	return 0;
}

bool used[MAXN],cyc=0;
int us[MAXN];
void cycle(int st)
{
//	bool us[MAXN];
	if(cyc)
		return;
	if(st==2)
		return;
	for(int i=0;i<a[st].size();i++)
	{
		if(used[a[st][i]])
		{
			cyc=1;
			return;
		}
		if(us[a[st][i]]==st)
			continue;
		used[a[st][i]]=1;
		us[a[st][i]]=st;
		cycle(a[st][i]);
		used[a[st][i]]=0;
	}
		
	
}

bool fl;
long long ways(int st)
{
	if(was[st]!=-1)
		return was[st];
	long long res=0;
	for(int i=0;i<a[st].size();i++)
		res+=ways(a[st][i]);
	if(res>=t)
		fl=1;
	res%=(long long)t;
	was[st]=res;
	return res;
}

int main()
{
	scanf("%d %d",&n,&m);
	for(int i=0;i<m;i++)
	{
		scanf("%d %d",&p,&q);
		a[p].PB(q);
	}
//	cout<<(double)clock()/(double)CLOCKS_PER_SEC<<"\n";
	if(!bfs())
	{
		printf("0\n");
		return 0;
	}
//	cout<<(double)clock()/(double)CLOCKS_PER_SEC<<"\n";
	used[1]=1;
	cycle(1);
//	cout<<(double)clock()/(double)CLOCKS_PER_SEC<<"\n";
	if(cyc)
	{
		printf("inf\n");
		return 0;
	}
	for(int i=1;i<=n;i++)
		was[i]=-1;
	was[2]=1;
	for(int i=0;i<13;i++)
		t*=10;
	ways(1);
//	cout<<(double)clock()/(double)CLOCKS_PER_SEC<<"\n";
//	cout<<was[1]<<"\n";
	if((was[1]<1000000000)&&(fl==0))
		cout<<was[1]<<"\n";
	else
		cout<<setw(9)<<setfill('0')<<was[1]%1000000000<<"\n";
//	printf("%d\n",was[1]);
	return 0;
}
