#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <stack>
#include <queue>
#include <iomanip>

#define INF 2000000000
#define EPS 1e-6
#define Repi(n) for (int i=0; i<n; i++)
#define Repj(n) for (int j=0; j<n; j++)
#define Repk(n) for (int k=0; k<n; k++)

#define PI pair<int,int>
#define UI unsigned int
#define PQ priority_queue
#define W1 while(1)
#define PD pair<double,double>
#define VI vector<int>
#define PB push_back
#define SZ size()
#define MP make_pair
#define x first
#define y second

#define pause system("pause")

using namespace std;

int n,m;
VI come[10010],go[10010];
long long ans[10010],MAX,mAX;
bool u[10010],big[10010];
int ord[10010],ordn,gr[10010],grn,grc[10010],grr[10010],p[10010];

void dfs(int v)
{
    if (u[v]) return;
    u[v]=true;
    Repi(come[v].SZ)
     dfs(come[v][i]);
    ord[ordn++]=v;
}

void dfs1(int v)
{
     if (gr[v]>0) return;
     gr[v]=grn;
     Repi(go[v].SZ)
      dfs1(go[v][i]);
}

inline bool path(int v)
{
     if (p[v]!=-1) return p[v];
     p[v]=false;
     Repi(come[v].SZ)
      if (path(come[v][i])) return p[v]=true;
     return p[v];
}

long long solve(int v)
{
    if (ans[v]>-1) return ans[v];
    ans[v]=0;
    Repi(come[v].SZ)
     if (p[come[v][i]])
      { ans[v]+=solve(come[v][i]); 
        if (ans[v]>=MAX) { ans[v]%=MAX; big[v]=true; } 
        big[v]|=big[come[v][i]]; }
//    cout<<v<<" -> "<<ans[v]<<endl; 
    return ans[v]; 
}


int main()
{
    int i,j,k,l;
     scanf("%d%d",&n,&m);
     Repi(m)
     {
      scanf("%d%d",&j,&k);
      if (j==2) continue;
      come[k].PB(j);
      go[j].PB(k);
     }
     
     dfs(2);
     reverse(ord,ord+ordn);
//     Repi(ordn) cout<<ord[i]<<" "; cout<<endl;
     
     Repi(ordn)
      if (gr[ord[i]]==0)
      { grn++;
        dfs1(ord[i]); }
//     Repi(ordn) cout<<gr[ord[i]]<<" "; cout<<endl;
     
     Repi(ordn) { grc[gr[ord[i]]]++; if (grc[gr[ord[i]]]>1) grr[gr[ord[i]]]=ord[i]; }
//     Repi(grn) cout<<grc[i+1]<<","<<grr[i+1]<<" "; cout<<endl;
     
     memset(p,255,sizeof(p)); p[1]=true;
     path(2);
     Repi(grn)
      if (grr[i+1]>0 && path(grr[i+1])) { printf("inf\n"); return 0; }

     Repi(n) ans[i+1]=(long long)-1;
     ans[1]=1; MAX=1; Repi(6) MAX*=(long long)1000;
//     mAX=1; Repi(5) mAX*=(long long)1000;
     solve(2);
     
     long long L=ans[2];
     
     if (L<1000000000 && !big[2]) { cout<<L<<"\n"; return 0; }
     string s; char c;
     while (s.SZ<9) { c=(char)(L%(long long)10)+'0'; L/=(long long)10; s=c+s; }
     cout<<s<<"\n";
     return 0;
}
