#include <cstdio>
#include <cmath>
#include <vector>

using namespace std;

vector <int> A[10001];
int n, m;

long long answ = 0;
long long cur = 1;
bool inf = false;
bool rounded = false;
bool used [10001];

void DFS (int p)
{
     if (inf == true) return;
     if (p == 2) 
     {
           answ += cur;
           if (answ > 1000000000)
           {
              rounded = true;
              answ %= 1000000000;
           } 
           return;
     }
     
     used[p] = true;
     for (int i = 0; i < A[p].size(); ++i)
     {
         if (used[A[p][i]] == true)
         {
             inf = true;
             return;
         }
         else
            if (A[p][i] != 0)
            {
                int mult = 1;
                for (int j = i + 1; j < A[p].size(); ++j)
                    if (A[p][i] == A[p][j]) 
                    {
                        ++mult;
                        A[p][j] = 0;
                    }
               cur *= mult;
               if (cur > 1000000000)
               {
                    rounded = true;
                    cur %= 1000000000;
               }     
               DFS(A[p][i]);
            }
     }
     used[p] = false;
}

int main ()
{
    scanf ("%d%d", &n, &m);
    int p, q;
    for (int i = 0; i < m; ++i)
    {
        scanf("%d%d", &p, &q);
        A[p].push_back (q);
    }
    DFS(1);
    if (inf == false)
       if (!rounded)
          printf ("%d\n", answ);
       else
       {
           for (int i = 1; i < (9 - log10(answ)); ++i)
               printf ("0");
           printf ("%d\n", answ);
       }
    else
       printf ("inf\n");
    return 0;
}
